-- MySQL dump 9.08
--
-- Host: localhost    Database: mesian_devel
---------------------------------------------------------
-- Server version	4.0.14-log

--
-- Table structure for table 'domain_priv'
--

CREATE TABLE domain_priv (
  no int(11) NOT NULL auto_increment,
  id varchar(10) NOT NULL default '0',
  name varchar(30) default NULL,
  quota int(10) unsigned NOT NULL default '10000000',
  valid set('1','0') NOT NULL default '1',
  lang tinytext,
  createdTime int(10) unsigned default '0',
  message_size_limit int(10) unsigned default '5000000',
  document_size_limit int(10) unsigned default '5000000',
  filter int(1) NOT NULL default '5',
  user_limit int(11) NOT NULL default '5',
  password varchar(40) NOT NULL default '',
  password_plain varchar(40) NOT NULL default '',
  block_address int(1) default '7',
  forum_name varchar(30) default NULL,
  www_name varchar(30) default NULL,
  PRIMARY KEY  (no)
) TYPE=InnoDB;

--
-- Table structure for table 'global_priv'
--

CREATE TABLE global_priv (
  no int(11) NOT NULL auto_increment,
  PRIMARY KEY  (no)
) TYPE=InnoDB;

--
-- Table structure for table 'mail_block_global'
--

CREATE TABLE mail_block_global (
  no int(6) NOT NULL default '0',
  address tinytext
) TYPE=MyISAM;

--
-- Table structure for table 'mail_entireMessage_unKnown'
--

CREATE TABLE mail_entireMessage_unKnown (
  no int(10) unsigned NOT NULL auto_increment,
  message longblob NOT NULL,
  size int(11) NOT NULL default '0',
  PRIMARY KEY  (no)
) TYPE=InnoDB;

--
-- Table structure for table 'mail_filter_global'
--

CREATE TABLE mail_filter_global (
  no int(6) NOT NULL auto_increment,
  f tinytext,
  t tinytext,
  s tinytext,
  payload_name tinytext,
  message_size int(11) NOT NULL default '0',
  directory_num varchar(10) default '0',
  sequence int(6) NOT NULL default '0',
  expression enum('0','1') NOT NULL default '0',
  t_o enum('0','1','2','3','4') default '0',
  f_o enum('0','1','2','3','4') default '0',
  s_o enum('0','1','2','3','4') default '0',
  p_o enum('0','1','2','3','4') default '0',
  m_o enum('0','1','2') default '0',
  t_c enum('0','1') default '0',
  f_c enum('0','1') default '0',
  s_c enum('0','1') default '0',
  p_c enum('0','1') default '0',
  PRIMARY KEY  (no)
) TYPE=InnoDB;

--
-- Table structure for table 'mail_queueIncoming'
--

CREATE TABLE mail_queueIncoming (
  no int(10) unsigned NOT NULL auto_increment,
  Toaddr tinytext NOT NULL,
  entireMessage longblob NOT NULL,
  result set('','1') default '',
  PRIMARY KEY  (no)
) TYPE=InnoDB;


--
-- Table structure for table 'mail_queueOutgoing'
--

CREATE TABLE mail_queueOutgoing (
  no int(10) unsigned NOT NULL auto_increment,
  Fromaddr tinytext NOT NULL,
  Toaddr tinytext NOT NULL,
  entireMessage longblob NOT NULL,
  method set('0','1') NOT NULL default '0',
  result set('','1') default NULL,
  message_id tinytext,
  PRIMARY KEY  (no)
) TYPE=InnoDB;

--
-- Table structure for table 'mail_unKnown'
--

CREATE TABLE mail_unKnown (
  no int(6) NOT NULL auto_increment,
  header mediumtext NOT NULL,
  headerSimple tinytext NOT NULL,
  textBody longtext NOT NULL,
  htmlBody longtext NOT NULL,
  payload longblob,
  headerPayload mediumtext NOT NULL,
  cid longblob,
  headerCid mediumtext NOT NULL,
  entireMessage int(11) NOT NULL default '0',
  isPayload int(11) NOT NULL default '0',
  isCid int(11) NOT NULL default '0',
  flag int(11) NOT NULL default '0',
  date varchar(10) NOT NULL default '0000000000',
  address tinytext,
  PRIMARY KEY  (no)
) TYPE=InnoDB;

--
-- Table structure for table 'sessions'
--

CREATE TABLE sessions (
  id varchar(40) NOT NULL default '',
  time varchar(15) NOT NULL default '0',
  time_start varchar(30) NOT NULL default '0',
  value text,
  server_id varchar(40) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=InnoDB;

--
-- Table structure for table 'user_alias_priv'
--

CREATE TABLE user_alias_priv (
  no int(11) NOT NULL auto_increment,
  name varchar(30) default NULL,
  domain varchar(40) NOT NULL default 'localhost',
  user_no int(11) NOT NULL default '0',
  valid set('1','0') default '1',
  PRIMARY KEY  (no),
  KEY name (name)
) TYPE=InnoDB;

--
-- Table structure for table 'user_priv'
--

CREATE TABLE user_priv (
  no int(11) NOT NULL auto_increment,
  name varchar(30) default NULL,
  domain varchar(40) NOT NULL default 'localhost',
  password varchar(40) NOT NULL default '',
  password_plain varchar(40) NOT NULL default '',
  quota int(10) unsigned NOT NULL default '10000000',
  valid set('1','0') NOT NULL default '1',
  lang tinytext,
  pageLimit int(10) unsigned NOT NULL default '10',
  createdTime int(10) unsigned default '0',
  id varchar(10) NOT NULL default '0',
  sort_method enum('title','author','ctime') default 'title',
  save_sort mediumtext,
  full_name varchar(30) default NULL,
  reply_to tinytext,
  signature mediumtext,
  block_address int(1) default '7',
  filter int(1) NOT NULL default '5',
  timeout int(11) NOT NULL default '1800',
  escape_filter_domain set('0','1') NOT NULL default '0',
  message_size_limit int(10) unsigned default '5000000',
  document_size_limit int(10) unsigned default '5000000',
  forward varchar(100) default NULL,
  htmlview_method tinytext,
  PRIMARY KEY  (no),
  KEY name (name)
) TYPE=InnoDB;

