# -*- coding: utf-8 -*-
import poplib

PORT = poplib.POP3_PORT

class Pop3 :

	Server = None
	num_of_message = 0

	message_id = 0

	def __init__ (self) :
		pass

	def connect (self, **kwargs) :

		if not kwargs.has_key("port") :
			port = PORT
		else :
			try :
				port = int(kwargs["port"])
			except :
				port = PORT

		return self.__connect( \
			kwargs["host"], \
			port, \
			kwargs["user"], \
			kwargs["password"] \
		)

	def __connect (self, servername, port, username, password) :
		try :
			self.Server = poplib.POP3(servername, port)
		except :	
			retval = False
		else :
			retval = self.__login(username, password)

			if retval : self.num_of_message = len(self.Server.list()[1])

		return retval

	def __login (self, username, password) :

		try :
			self.Server.user(username)
			self.Server.pass_(password)
		except :
			retval = False
		else :
			self.message_id = 0 # initialize message list number.
			retval = True

		return retval

	def logout (self) :
		try :
			self.Server.quit()
		except :
			pass

	def fetch_all (self) :

		message = []
		for i in range(self.num_of_message) :
			message.append(self.fetch())

		retval = message

		return retval

	def remove (self, message_id = None) :

		if not message_id : message_id = self.message_id - 1

		try :
			self.Server.dele(message_id)
		except :
			pass

		return True

	def fetch (self) :

		try :
			retval = "\n".join(self.Server.retr(self.message_id + 1)[1])
		except poplib.error_proto :
			retval = False
		else :
			#self.__remove(self.message_id + 1)
			self.message_id += 1

		if retval == None : retval = False

		return retval

"""
Description
-----------

Example

	M = poplib.POP3('localhost')
	M.user(getpass.getuser())
	M.pass_(getpass.getpass())
	numMessages = len(M.list()[1])
	for i in range(numMessages):
		 for j in M.retr(i+1)[1]:
			  print j

ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Pop3.py"

